//------------------------------------------------------------
// 
// SSE2030: Introduction to Computer Systems (Fall 2017)
//
// PA3: Pixelizing an image
//
// November 13, 2017
//
// Jin-Soo Kim (jinsookim@skku.edu)
// Computer Systems Laboratory
// Sungkyunkwan University
// http://csl.skku.edu
//
//------------------------------------------------------------


#define	BMP_MAGIC		((unsigned short) 0x4d42)


#define BITMAPCOREHEADER	(12)
#define BITMAPCOREHADER2	(64)
#define BITMAPINFOHEADER	(40)
#define BITMAPV4HEADER		(108)
#define BITMAPV5HEADER		(124)

#define BI_RGB			0
#define BI_RLE8			1
#define BI_RLE4			2
#define BI_BITFIELDS		3
#define BI_JPEG			4
#define BI_PNG			5



typedef struct {
	unsigned short 	magic;
	unsigned short	length_low;
	unsigned short	length_high;
	unsigned short	pad1;
	unsigned short 	pad2;
	unsigned short	offset_low;
	unsigned short 	offset_high;
} bmp_header;


typedef struct {
	unsigned int	size;
	int		width;
	int		height;
	unsigned short	planes;
	unsigned short	bitcount;
	unsigned int	compression;
	unsigned int	size_image;
	int		xpixels_per_meter;
	int		ypixels_per_meter;
	unsigned int	colors_used;
	unsigned int	colors_important;
} bi_header;

struct bmp_info {
	unsigned char	*memptr;
	unsigned char	*imgptr;
	int		filesize;
	int		offset;
	int		width;
	int		height;
};

void bmp_mosaic (unsigned char *imgptr, int width, int height, int size);
